declare type FetchFunction = (id: string) => Promise<{
    code?: string;
    externalize?: string;
}>;
interface ModuleCache {
    promise?: Promise<any>;
    exports?: any;
    code?: string;
}
interface ViteNodeRunnerOptions {
    fetchModule: FetchFunction;
    root: string;
    base?: string;
    moduleCache?: Map<string, ModuleCache>;
    interpretDefault?: boolean;
    requestStubs?: Record<string, any>;
}

declare class ViteNodeRunner {
    options: ViteNodeRunnerOptions;
    root: string;
    externalCache: Map<string, string | Promise<false | string>>;
    moduleCache: Map<string, ModuleCache>;
    constructor(options: ViteNodeRunnerOptions);
    run(file: string): Promise<any>;
    cachedRequest(rawId: string, callstack: string[]): Promise<any>;
    directRequest(id: string, fsPath: string, callstack: string[]): Promise<any>;
    prepareContext(context: Record<string, any>): Record<string, any>;
    setCache(id: string, mod: Partial<ModuleCache>): void;
}

export { ViteNodeRunner };
